import { Construct } from 'constructs';
/**
 * Get the value of an SSM Parameter Store value. This method will reuse the same CustomResource, reducing the number
 * of lookups to the same resource within a stack.
 */
export declare class DlzSsmReaderStackCache {
    private cachedValues;
    /**
     * Fetch type `always` will always fetch the value from SSM Parameter Store, this will produce a CDK diff every time.
     * Fetch type `value-change` will fetch the value from SSM Parameter Store only when the value changes, this will not
     * produce a CDK diff every time.
     *
     * @param scope
     * @param id
     * @param accountId
     * @param region
     * @param name
     * @param withDecryption
     * @param fetchType
     */
    getValue(scope: Construct, id: string, accountId: string, region: string, name: string, fetchType?: 'always' | 'value-change', withDecryption?: boolean): string;
}
