import { Construct } from 'constructs';
/**
 * A user in the IAM Identity Center
 */
export interface IdentityStoreUserProps {
    readonly userName: string;
    readonly name: string;
    readonly surname: string;
}
/**
 * A user in the IAM Identity Center
 */
export interface IdentityStoreUserPropsExt {
    readonly userName: string;
    readonly identityStoreId: string;
    readonly name: IdentityStoreUserNameProps;
    readonly displayName: string;
    readonly email: IdentityStoreUserEmailsProps;
}
/**
 * The name of a user in the IAM Identity Center
 */
export interface IdentityStoreUserNameProps {
    readonly formatted: string;
    readonly familyName: string;
    readonly givenName: string;
    readonly middleName?: string;
    readonly honorificPrefix?: string;
    readonly honorificSuffix?: string;
}
/**
 * The email of a user in the IAM Identity Center
 */
export interface IdentityStoreUserEmailsProps {
    readonly value: string;
    readonly type: string;
    readonly primary?: boolean;
}
/**
 * A user in the IAM Identity Center
 */
export declare class IdentityStoreUser extends Construct {
    static fetchCodeDirectory(): string;
    readonly userId: string;
    constructor(scope: Construct, id: string, props: IdentityStoreUserPropsExt);
}
