import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { IsMemberInGroupsResponseFilterSensitiveLog, } from "../models/models_0";
import { de_IsMemberInGroupsCommand, se_IsMemberInGroupsCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class IsMemberInGroupsCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("AWSIdentityStore", "IsMemberInGroups", {})
    .n("IdentitystoreClient", "IsMemberInGroupsCommand")
    .f(void 0, IsMemberInGroupsResponseFilterSensitiveLog)
    .ser(se_IsMemberInGroupsCommand)
    .de(de_IsMemberInGroupsCommand)
    .build() {
}
